class C
  def self.inherited(klass)
    puts "#{klass}が#{self}を継承しました"
  end
end

module M
  def self.extended(klass)
    puts "#{klass}が#{self}をextendしました"
  end

  def self.included(klass)
    puts "#{klass}が#{self}をincludeしました"
  end

  def self.prepended(klass)
    puts "#{klass}が#{self}をprependしました"
  end
end

class A < C
end

module B
  extend M
  include M
  prepend M
end
