require 'overrider'

class SuperClass
  def foo
  end
end

class SubClass < SuperClass
  extend Overrider
  # SuperClassに存在するメソッドを
  # overrideしているのでok
  override def foo
  end

  # barメソッドはSuperClassに存在しないため
  # 例外が発生する
  override def bar
  end
end
