class Hash
  def method_missing(name, *args)
    if match = name.match(/^has_(.+)\?$/)
      !!self[match[1].to_sym]
    else
      super
    end
  end
end

hash = { foo: 1 }

p hash.has_foo? # => true
p hash.has_bar? # => false
p hash.aaa # NoMethodError
