def trace_for_override(owner)
  @__overrider_trace_point ||= TracePoint.trace(:end, :c_return, :return, :raise) do |t|
    # （中略）

    target_class_end = klass == owner && t.event == :end
    target_class_new_end = (klass == Class || klass == Module) && t.event == :c_return && t.method_id == :new && t.return_value == owner

    if target_class_end || target_class_new_end || override_at_outer # (d1)
      override_methods.each do |meth|
        unless meth.super_method # (d2)
          @__overrider_trace_point.disable
          @__overrider_trace_point = nil
          raise NoSuperMethodError.new(self, meth, caller(4))
        end
      end
      @__overrider_trace_point.disable
      @__overrider_trace_point = nil
    end
  end
end
